// More information about this indicator can be found at:
// http://fxcodebase.com/code/viewtopic.php?f=38&t=68338

//+------------------------------------------------------------------+
//|                               Copyright © 2019, Gehtsoft USA LLC | 
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |
//|                                          mario.jemic@gmail.com   |
//+------------------------------------------------------------------+
//|                                 Support our efforts by donating  |
//|                                  Paypal : https://goo.gl/9Rj74e  |
//+------------------------------------------------------------------+
//|                                Patreon :  https://goo.gl/GdXWeN  |
// modified by banzai from Mario Jemic template 
// July 28th, 2020
// not for sale, rent, auction, nor lease

// +----------------------------------------------------------------------------------------+ //
// |                                            XARD                                        | //
// |----------------------------------------------------------------------------------------| //
// | Programming language:     MQL4                                                         | //
// | Development platform:     MetaTrader 4                                                 | //
// |          End product:     Indicator for MetaTrader 4 designed                          | //
// +----------------------------------------------------------------------------------------+ //

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 C'100,150,180'
#property indicator_color2 clrGold //GBupband
#property indicator_color3 clrGold  //GBdnband
#property indicator_color4 clrBlue
#property indicator_color5 clrRed //C'0xE1,0x00,0x00'
#property indicator_width1 12
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 6
#property indicator_width5 6

extern int GBper = 10;
extern int GBshuffle = 7;
extern double GBdev = 3.618;
extern bool AlertsOn = FALSE;
extern bool AlertsOnCurrent = TRUE;
extern bool AlertsMessage = FALSE;
extern bool AlertsSound = TRUE;
extern bool AlertsEmail = FALSE;

extern string             button_note1          = "------------------------------";
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; // chart btn_corner for anchoring
extern string             btn_text              = "GB";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;                             //btn__font size
extern color              btn_text_ON_color     = clrWhite;
extern color              btn_text_OFF_color    = clrRed;
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 80;                                     //btn__x
extern int                button_y              = 33;                                     //btn__y
extern int                btn_Width             = 60;                                 //btn__width
extern int                btn_Height            = 20;                                //btn__height
extern string             button_note2          = "------------------------------";

bool                      show_data             = true;
string IndicatorName, IndicatorObjPrefix;
//template code end1
int shift1 = 0;
int shift2 = 0;
double GBsignal[];
double GBshift[], GBbgd[];
double GBupTrend[];
double GBdnTrend[];
double GBupband[];
double GBdnband[];
double ExtBuffer01[];
int    GBtimeframe01;
string Str01;
string NothingStr = "nothing";
datetime GBTime01;
//+------------------------------------------------------------------+
string GenerateIndicatorName(const string target)
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//+------------------------------------------------------------------+
string buttonId;

int init()
{
   IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName);
   IndicatorDigits(Digits);
   
   double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0;
   
   ChartSetInteger(0, CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix + "CloseButton";
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(0, buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(0, buttonId, OBJPROP_XDISTANCE, button_x);
// put init() here
   IndicatorBuffers(8);
   SetIndexBuffer(7, ExtBuffer01);
   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS));
   if (GBper < 2) GBper = 12;
   int w = GBper - 1;
   string GoldBands01 = "GoldBands(";
   IndicatorShortName(GoldBands01 + GBper + ")");
  
   SetIndexBuffer(0,GBbgd);     SetIndexStyle(0,DRAW_LINE); 
   SetIndexShift(0,shift2);  SetIndexDrawBegin(0,w);

   SetIndexBuffer(1, GBupband); SetIndexStyle(1, DRAW_LINE); //GBupband
   SetIndexShift(1, shift2); SetIndexDrawBegin(1, w); //GBupband
 
   SetIndexBuffer(2, GBdnband); SetIndexStyle(2, DRAW_LINE);
   SetIndexShift(2, shift2);  SetIndexDrawBegin(2, w);
   
   SetIndexBuffer(3, GBupTrend); SetIndexStyle(3, DRAW_LINE);
   SetIndexShift(3, shift2); SetIndexDrawBegin(3, w);

   SetIndexBuffer(4, GBdnTrend); SetIndexStyle(4, DRAW_LINE);
   SetIndexShift(4, shift2); SetIndexDrawBegin(4, w);
   
   SetIndexBuffer(5, GBsignal); SetIndexStyle(5, DRAW_NONE);
   SetIndexShift(5, shift2); SetIndexDrawBegin(5, w);
      
   SetIndexBuffer(6, GBshift); SetIndexStyle(6, DRAW_NONE);
   SetIndexShift(6, shift2); SetIndexDrawBegin(6, w);
 
   switch (GBtimeframe01) {
   case PERIOD_M1:
      Str01 = " M1";
      break;
   case PERIOD_M5:
      Str01 = " M5";
      break;
   case PERIOD_M15:
      Str01 = " M15";
      break;
   case PERIOD_M30:
      Str01 = " M30";
      break;
   case PERIOD_H1:
      Str01 = " H1";
      break;
   case PERIOD_H4:
      Str01 = " H4";
      break;
   case PERIOD_D1:
      Str01 = " D1";
      break;
   case PERIOD_W1:
      Str01 = " W1";
      break;
   case PERIOD_MN1:
      Str01 = " MN1";
      break;
   default:
      GBtimeframe01 = Period();
      init();
      return (0);
   }
   
   return 0;
}
//+------------------------------------------------------------------+
void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
      ObjectDelete    (0,buttonID);
      ObjectCreate    (0,buttonID,OBJ_BUTTON,0,0,0);
      ObjectSetInteger(0,buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_TYPE,BORDER_RAISED);
      ObjectSetInteger(0,buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(0,buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (0,buttonID,OBJPROP_FONT,font);
      ObjectSetString (0,buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(0,buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(0,buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(0,buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(0,buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(0,buttonID,OBJPROP_YDISTANCE,9999);
}
//+------------------------------------------------------------------+
int deinit()
{
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);
   ObjectsDeleteAll(1, OBJ_LABEL);
   return 0;
}
//+------------------------------------------------------------------+
bool recalc = true;

void handleButtonClicks()
{
   if (ObjectGetInteger(0, buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(0, buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
}
//+------------------------------------------------------------------+
int start()
{
   handleButtonClicks();
   recalc = false;

   int w; double total,signal,sum2,sum1;  GoldBands();  sma();
   if(Bars <= GBshuffle) return (0);
   int countedbars=IndicatorCounted();
   for(int i=1;i<=GBshuffle;i++){
       GBshift[Bars-i]=EMPTY_VALUE;
      GBupband[Bars-i]=EMPTY_VALUE;
      GBdnband[Bars-i]=EMPTY_VALUE;
     GBupTrend[Bars-i]=EMPTY_VALUE;
     GBdnTrend[Bars-i]=EMPTY_VALUE;}

   int x = Bars - countedbars;
   if (countedbars > 0) x++;
   i = Bars - GBshuffle + 1;
   if (countedbars > GBshuffle - 1) i = Bars - countedbars - 1;
   while (i >= 0) {
      signal = 0.0;
      w = i + GBshuffle - 1;
      sum2 = GBshift[i];
      while (w >= i) {
         sum1 = GBsignal[w] - sum2;
         signal += sum1 * sum1;
         w--;
      }
      total = GBdev * MathSqrt(signal / GBshuffle);
      GBupband[i] = sum2 + total;
      GBdnband[i] = sum2 - total;
      i--;
   }
   i = Bars - GBshuffle + 1;
   if (countedbars > GBshuffle - 1) i = Bars - countedbars - 1;

   while (i >= 0) {
      if (GBshift[i] < GBsignal[i]) 
         {GBupTrend[i] = GBshift[i]; GBdnTrend[i] = EMPTY_VALUE;
         if (GBupTrend[i + 1] == EMPTY_VALUE) GBupTrend[i + 1] = GBshift[i + 1];} 
      else {
            if (GBshift[i] > GBsignal[i]) 
               {GBdnTrend[i] = GBshift[i]; GBupTrend[i] = EMPTY_VALUE;
                if (GBdnTrend[i + 1] == EMPTY_VALUE) GBdnTrend[i + 1] = GBshift[i + 1]; 
               }
           } //else
      GBbgd[i]=GBshift[i]; i--;
      manageAlerts();
   }

      if (show_data)
      {
       ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color);
       for (int banzai=0; banzai<5; banzai++)
           SetIndexStyle(banzai,DRAW_LINE);
      }
      else
      {
       ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
       for (banzai=0; banzai<5; banzai++)
           SetIndexStyle(banzai,DRAW_NONE);
      }
   return 0;
}
//+------------------------------------------------------------------+
void GoldBands() {
   double close;
   double sum = 0.0;
   double Band2 = 0.0;
   int bars = 0;
   int limit3 = Bars - shift1 - 1;
   if (limit3 < GBper) limit3 = GBper;
   int j = 1;
   while (j <= GBper) {
      close = Close[limit3];
      sum += close * j;
      Band2 += close;
      bars += j;
      j++;
      limit3--;
   }
   limit3++;
   j = limit3 + GBper;
   while (limit3 >= 0) {
      GBsignal[limit3] = sum / bars;
      if (limit3 == 0) break;
      limit3--;
      j--;
      close = Close[limit3];
      sum = sum - Band2 + close * GBper;
      Band2 -= Close[j];
      Band2 += close;
   }
   if (shift1 < 1) for (j = 1; j < GBper; j++) GBsignal[Bars - j] = 0;
}
//+------------------------------------------------------------------------------------------------------------------+
void sma() {
   double sum = 0;
   int limit2 = Bars - shift1 - 1;
   if (limit2 < GBshuffle) limit2 = GBshuffle;
   int k = 1;
   while (k < GBshuffle) {
      sum += GBsignal[limit2];
      k++;
      limit2--;
   }
   while (limit2 >= 0) {
      sum += GBsignal[limit2];
      GBshift[limit2] = sum / GBshuffle;
      sum -= GBsignal[limit2 + GBshuffle - 1];
      limit2--;
   }
   if (shift1 < 1) for (k = 1; k < GBshuffle; k++) GBshift[Bars - k] = 0;
}
//+------------------------------------------------------------------------------------------------------------------+
void manageAlerts() {
   int w;
   if (AlertsOn) {
      if (AlertsOnCurrent) w = 0;
      else w = 1;
      w = iBarShift(NULL, 0, iTime(NULL, 0, w));
      if (ExtBuffer01[w] != ExtBuffer01[w + 1]) {
         if (ExtBuffer01[w] == 1.0) doAlert(w, "up");
         if (ExtBuffer01[w] == -1.0) doAlert(w, "down");
      }
   }
}
//+------------------------------------------------------------------------------------------------------------------+
void doAlert(int Yoda, string aStr02) {
   string zard777;
   if (NothingStr != aStr02 || GBTime01 != Time[Yoda]) {
      NothingStr = aStr02;
      GBTime01 = Time[Yoda];
      zard777 = StringConcatenate(Symbol(), " ", Str01, " GoldBands : direction changed to ", aStr02);
      if (AlertsMessage) Alert(zard777);
      if (AlertsEmail) {
         SendMail(zard777, zard777 
            + "\nLocal time " + TimeToStr(TimeLocal(), TIME_SECONDS) + "" 
         + "\nBroker time " + TimeToStr(TimeCurrent(), TIME_SECONDS));
      }
      if (AlertsSound) PlaySound("good-bad-ugly.wav");
   }
}
//+------------------------------------------------------------------------------------------------------------------+

